'use strict';

function DatabaseStatusCtrl($scope, database) {

	$scope.open = false;
	$scope.closeable = false;
	$scope.modification = null;

	$scope.$on("database:modification-start", function(event, modification) {
		$scope.open = true;
		$scope.closeable = false;
		$scope.modification = modification;
	});

	$scope.$on("database:modification-done", function(event, modification) {
		if (modification.direct) {
			$scope.closeable = true;
		} else {
			$scope.open = false;
		}
	});

	$scope.percentDisplay = function() {
		if ($scope.modification.progress) {
			return Math.round($scope.modification.progress.percent * 100) + "%";
		} else {
			return "";
		}
	};

	$scope.percentValue = function() {
		if ($scope.modification.progress) {
			return $scope.modification.progress.percent * 100 + "%";
		} else {
			return "100%";
		}
	};

	$scope.close = function() {
		if (!$scope.closeable) return;
		$scope.open = false;
		$scope.closeable = false;
	};

}
